function RGB(A,R,G,B) return (A)*0x8000 + (B)*0x0400+ (G)*0x0020 + (R); end;

dofile( "menu2.lua" );

-- palette
function SetPalette( num, dat )
	num = 0x05000000 + num * 32;
	for j=0,15,1 do
		poke16( num + j*2, dat[j+1] );
	end;
end;
-- BG char
function SetChar( num, dat )
	num = 0x6020000 + num * 32;
	for j=0,7,1 do
		poke32( num + j*4, dat[j+1] );
	end;
end;
-- BG Tile
function SetTile( x, y , pat, pal, hf, vf )
	local dt = pal*0x1000 + hf*0x0400 + vf*0x0800 + pat;
	poke16( 0x6028000 + ( (y*32 + x) * 2 ), dt );
end;

-- SP palette
function SetSPPalette( num, dat )
	num = 0x05000200 + num * 32;
	for j=0,15,1 do
		poke16( num + j*2, dat[j+1] );
	end;
end;
-- SP Char
function SetSPChar( num, dat )
	num = 0x06400000 + num * 32;
	for j=0,7,1 do
		poke32( num + j*4, dat[j+1] );
	end;
end;
-- SP Put
function PutSprite( no, x, y , pat, pal, hf, vf, siz , pri,  hide, mos )
	local atr1 = mos * 0x1000 + hide * 0x100 + y;
	local atr2 = siz * 0x4000 + hf * 0x2000 + vf * 0x1000 + x;
	local atr3 = pal * 0x1000 + pri * 0x0400 + pat;
	poke16( 0x7000000  + no * 8    , atr1 );
	poke16( 0x7000000  + no * 8 + 2, atr2 );
	poke16( 0x7000000  + no * 8 + 4, atr3 );
end;



pal = {};
pal[0] = { 0x0000, 0x00FC, 0xEEFE, 0x0000, 0xFFF0, 0xAA8A, 0x9989, 0x88F8, 0x77F7, 
           0x66F6, 0x55F5, 0x44F4, 0xCCFC, 0xBBFB, 0xAA8A, 0x9989, 0x88F8, 0x77F7, };

SetPalette( 0, pal[0] );
SetPalette( 1, pal[0] );


ui.LOG( "Set PAL" );

dt3 = {
 	 {  0x00000000,
		0x00000000,
		0x00000000,
		0x00000000,
		0x00000000,
		0x00000000,
		0x00000000,
		0x00000000 },

 	 {  0x44444444,
		0x44444444,
		0x44444444,
		0x44444444,
		0x44444444,
		0x44444444,
		0x44444444,
		0x44444444,},

	 {  0x01111110,
	 	0x10022009,
	 	0x10002209,
	 	0x12222229,
	    0x12222229,
	    0x10002209,
	    0x10022009,
	    0x09999990,},
};

for i=0,2,1 do SetChar( i, dt3[i+1] ) end;

ui.LOG( "Set CHAR" );

for i=0,31,1 do
	for j=0,31,1 do
		SetTile(  i, j, 1, 0, 0, 0 );
	end;
end;
SetTile(  2, 1, 1, 0, 0, 0 );
SetTile(  3, 1, 1, 1, 0, 0 );
SetTile( 10,10, 1, 0, 0, 0 );
SetTile( 10,11, 1, 0, 0, 1 );
SetTile( 11,12, 1, 0, 1, 0 );

ui.LOG( "Set Tile" );

-- mosaic --
poke16( 0x400004C, 0x3333 );


-- Sprite test --
SetSPPalette(0, pal[0] );
SetSPPalette(1, pal[0] );

dofile( "spdat.lua" );

for i=0,63,1 do SetSPChar( i, sp[i+1] ) end;
ui.LOG( "Set SPR" );

--         no, x,  y , pat, pal, hf, vf, siz , pri,  hide, mos )
PutSprite( 0,  10, 50,  0,   1,   0,  1,  1,    0,    0,   1 )
PutSprite( 1,  30, 50,  4,   1,   0,  1,  1,    0,    0,   1 )
PutSprite( 2,  50, 50,  8,   1,   0,  1,  1,    0,    0,   1 )
PutSprite( 3,  70, 50, 12,   1,   0,  1,  1,    0,    0,   1 )
PutSprite( 4,  90, 50, 16,   1,   0,  1,  1,    0,    0,   1 )
PutSprite( 5, 110, 50, 20,   1,   0,  1,  1,    0,    0,   1 )
PutSprite( 6, 130, 50, 24,   1,   0,  1,  1,    0,    0,   1 )
PutSprite( 7, 150, 50, 28,   1,   0,  1,  1,    0,    0,   1 )
PutSprite( 8, 170, 50, 32,   1,   0,  1,  1,    0,    0,   1 )
PutSprite( 9, 190, 50, 36,   1,   0,  1,  1,    0,    0,   1 )
PutSprite( 9, 210, 50, 40,   1,   0,  1,  1,    0,    0,   1 )


ui.LOG( "PUT SPR" );

-- BITMAP TEST
for j=0,31,1 do
	for i=0,31,1 do
		poke16( 0x6000000+j*512+i*2, RGB(1,j,i,i) );
	end;
end;

for i=0,31,1 do
	ui.LOG( peek16( 0x6000000+i*2 ) );
end;

Player = {
	brk = 0;
	x = 0;
	y = 100;
	dx = 0;
	dy = 0;
	pt = 0;
	d  = 0;
	cnt = 20;
}

function player_routine(p)
	local dkeys, hkeys;

	dkeys = ui.keysDown();
	hkeys = ui.keysHeld();

	if dkeys.LEFT  then if p.dx >  2 then p.brk=1; end; end;
	if dkeys.RIGHT then if p.dx < -2 then p.brk=1; end; end;

--	if hkeys.UP    then p.dy = p.dy - 2; end;
--	if hkeys.DOWN  then p.dy = p.dy + 2; end;
	if hkeys.LEFT  then 
		p.dx = p.dx - 2;
		if p.dx < 0 then p.brk = 0; end;
 	end;
	if hkeys.RIGHT then
		p.dx = p.dx + 2;
		if p.dx > 0 then p.brk = 0; end;
	end;

	if not( hkeys.UP or hkeys.DOWN) then
		if p.dy < 0 then 
			p.dy = p.dy + 1; 
			if p.dy > 0 then  p.dy =0; end;
		end;
		if p.dy > 0 then 
			p.dy = p.dy - 1; 
			if p.dy < 0 then  p.dy = 0; end;
		end;
	end;
	if not( hkeys.LEFT or hkeys.RIGHT) then
		if p.dx < 0 then
			p.dx = p.dx + 1;
			if p.dx > 0 then  p.dx = 0; end;
		end;
		if p.dx > 0 then
			p.dx = p.dx - 1;
			if p.dx < 0 then  p.dx = 0; end;
		 end;
	end;

	if p.dx >  20 then p.dx =  20; end;
	if p.dx < -20 then p.dx = -20; end;
	if p.dy >  20 then p.dy =  20; end;
	if p.dy < -20 then p.dy = -20; end;

	p.x = p.x + p.dx / 10;
	p.y = p.y + p.dy / 10;

	if p.dx == 0 then 
		p.pt = 4;
		p.brk = 0;
	else
--		ui.LOG( dx );
		if p.dx > 0 then p.d = 1; end;
		if p.dx < 0 then p.d = 0; end;
		if p.brk == 1 then
			p.pt = 32;
			if p.dx < 0 then p.d = 1 else p.d = 0 end;
		else
			if p.cnt > 10  then p.pt = 0; else p.pt = 4; end;
		end;
	end;
	if p.x < 0   then p.x = 255; end;
	if p.x > 255 then p.x = 0;   end;
	if p.y < 0   then p.y = 255; end;
	if p.y > 255 then p.y = 0;   end;
	PutSprite( 0,  p.x, p.y,  p.pt,   1,   0,  p.d,  1,    0,    0, 1 )

	p.cnt = p.cnt - 1;
	if p.cnt == 0 then p.cnt = 20; end;

--	poke16( 0x04000014 , x );
--	poke16( 0x04000016 , y );
--	coroutine.yield(x, y);
	return 0,0;
end;

-- player = coroutine.create ( player_routine );


sx = 0;
sy = 0;
while(true)	do 
	ui.waitForVBlank(1);
	ui.scanKeys();
	player_routine(Player);
--	ui.LOG( "dy:"..sy .. "  dx:".. sx );
end;

